function [hpd,hpdregion,actualcoverage]=HPDregions(data,coverage)

[density,points]=densest(data); % Kernel density estimator. Optimal bandwidth under normal dist.
gridlength=abs(points(2)-points(1));
[sorted index]=sortrows([points density],2);
pointssort=sorted(:,1);
densitysort=sorted(:,2);

i=1;
while trapz(densitysort(densitysort>densitysort(i)))*gridlength>coverage
    trapz(densitysort(densitysort>densitysort(i)))*gridlength;
   i=i+1;
end
actualcoverage=trapz(densitysort(densitysort>=densitysort(i)))*gridlength;
hpdregion=sort(pointssort(i:size(pointssort,1)));
breakpoints=find(diff(hpdregion)>1.9*gridlength);
numberofintervals=length(breakpoints)+1;

hpd=zeros(numberofintervals,2);
switch numberofintervals
case 1 % only one interval
   hpd=[hpdregion(1) hpdregion(length(hpdregion))];
otherwise % more than one interval
   for j=1:numberofintervals
      switch j
      case 1
      	hpd(j,:)=[min(hpdregion) hpdregion(breakpoints(j))];
      case numberofintervals
         hpd(j,:)=[hpdregion(breakpoints(j-1)+1) max(hpdregion)];
      otherwise
         hpd(j,:)=[hpdregion(breakpoints(j-1)+1) hpdregion(breakpoints(j))];
      end
   end  
end